*--- vypis aktivnych suborov zo sietoveho adresara
#include bslib.hdr
#include bsnetw.hdr
#include data.hdr
#include date.hdr
#include fileio.hdr
#include io.hdr
#include system.hdr
#include string.hdr
*---
* Vypise stav aktivnych suborov v sieti
* Ak sa nasiel aspon jeden aktivny subor vrati ERROR LEVEL 1
*
* tato verzia programu bola prekonana v CC-- Peter Cellik
*
*-------------------
PROCEDURE FORCE_MAIN
*-------------------
PARAMETERS CONST CHAR(127) Cmnd_line
*---
*--- lokalne premenne
VARDEF
  UINT		Dos_error, Bodka, Dlzka
  CHAR(9)	Meno_suboru
  CHAR(12)	Plne_meno_suboru
  CHAR(127)	Cesta, Hladam
  LOGICAL	Uspech, Share_ok, Dalej, Aktivny
ENDDEF
*---
SET Date GERMAN
SET CENTURY ON
Uspech = .T.
Aktivny = .F.
*--- najdi prvy subor
Cesta = TRIM(Cmnd_line)
*--- dopln \ ak tam neni
IF Cesta <> ""
  Bodka = LEN(Cesta)
  IF SUBSTR(Cesta,Bodka,1) <> "\"
    Cesta = Cesta + "\"
  ENDIF
ENDIF
*--- vsetky subory v adresari, ziadna maska nie sme na plese
Hladam = Cesta + "*.*"
Uspech = Find_first( Hladam, 0X27 )
*--- ak je aspon jeden subor
IF Uspech
  *--- az do zblbnutia
  DO WHILE .T.
    Plne_meno_suboru = Find_fstr()
    *--- skus otvorit EXCLUSIVE
    Dos_error = Net_file(Cesta+Plne_meno_suboru,"E")
    *--- ak to neslo este SHARED
    IF Dos_error = 0 &&& <> 0
      IF Net_file(Cesta+Plne_meno_suboru,"S") = 0
        Share_ok = .T.
      ELSE
        Share_ok = .F.
      ENDIF
      *--- zobraz v peknom tvare
      Bodka = AT(".",Plne_meno_suboru)
      Meno_suboru = SUBSTR(Plne_meno_suboru,1,Bodka-1)
      Meno_suboru = Meno_suboru + SPACE(9)
      Dlzka = Fb_write(&STd_out,Meno_suboru+" ",10)
      *--- pripona
      Dlzka = Fb_write(&STd_out,SUBSTR(Plne_meno_suboru,Bodka+1,3)+" ",4)
      *--- velkost
      Dlzka = Fb_write(&STd_out,STR(Find_fsize(),8,0)+" ",9)
      *--- datum
      Dlzka = Fb_write(&STd_out,DTOC(Find_fdate())+" ",11)
      *--- cas bez sekund ako MSDOS
      Dlzka = Fb_write(&STd_out,SUBSTR(Find_ftime(),1,5)+" ",6)
      *--- ukaz mu skutocny stav situacie
      IF Share_ok
        Dlzka = Fb_write(&STd_out,"active"+CHR(13)+CHR(10),8)
      ELSE
        Dlzka = Fb_write(&STd_out,"active and locked"+CHR(13)+CHR(10),19)
      ENDIF
      *--- pamataj si ze bol aktivny subor
      Aktivny = .T.
    ENDIF
    *--- dalsi paan na holenie
    Dalej = Find_next()
    IF .NOT. Dalej
      EXIT
    ENDIF
  ENDDO
ENDIF
*--- pre pripad, ze ma bude volat z .BAT mu vratim ERRORLEVEL
IF Aktivny
  QUIT 1
ELSE
  QUIT 0
ENDIF
ENDPRO
